#include "SoftwareSerial.h"
#define rot_switch 4
#define rot_a 5
#define rot_b 6

double rot_enc_val = 0; 
int rot_a_state = 0;
int rot_b_state = 0;
int rot_a_state_prev = 0;  
int rot_switch_state = 0;
int rot_switch_state_prev = 0;
SoftwareSerial mySerial(0, 1);

void setup() { 
  mySerial.println("resetting");
  
  pinMode (rot_switch,INPUT_PULLUP);
  pinMode (rot_a,INPUT_PULLUP);
  pinMode (rot_b,INPUT_PULLUP);
  
  mySerial.begin (9600);
  rot_a_state_prev = digitalRead(rot_a);     
} 

void loop() { 
  rot_switch_state = 1 - digitalRead(rot_switch);  
  rot_a_state = digitalRead(rot_a);

   // if the current & previous states of rot_a are different, a pulse has occurred
  if (rot_a_state != rot_a_state_prev){
    rot_b_state = digitalRead(rot_b);
      
    if (rot_a_state == rot_b_state) {
        rot_enc_val = rot_enc_val + 0.5; // if a & b are the same, increment
      } else {
        rot_enc_val = rot_enc_val - 0.5; // if a & b are the different, decrement
      }

      mySerial.print("count: ");
      mySerial.println(rot_enc_val);
      rot_a_state_prev = rot_a_state;
    }
    
    if (rot_switch_state != rot_switch_state_prev){
      mySerial.print("switch: ");
      mySerial.println(rot_switch_state);
      rot_switch_state_prev = rot_switch_state;
    }
}
